Subject: bug#34138: 27.0.50; Delayed display of PDF file images

From: Stephen Berman <[email-masked]>
Date: Mon, 21 Jan 2019 16:20:44 +0100

On Mon, 21 Jan 2019 08:52:28 +0100 martin rudalics <[email-masked]> wrote:

>>> It seems that 'doc-view-new-window-function' fails in some way.  This
>>> time I have to CC Tassilo.  Maybe he has a clue.
>>
>> No, sorry, not really.  I've tried reproducing Stephen's issue both with
>> -Q (using doc-view) and with my configuration (which also uses
>> pdf-view-mode).  But for me the greeting text and then the image of the
>> first page for doc-view or the image of the first page for pdf-view-mode
>> are displayed without any delay.
>>
>> I'm running the current master, 5961e4fa42.
>
> Strange because Andreas said that he can reproduce it as well.  I'm
> afraid we have to wait for further people to kick in to get a common
> pattern of why this can fail.  To me this looks like a race condition
> where with the old window configuration change convention the image
> producing system was reliably incapable of providing the image at the
> time the hook was run while with the new convention the image may have
> been already produced at the time the hook is run.

It does seem like a race condition.  I also had this suspicion after
getting surprising and seemingly conflicting gdb backtraces that Eli
asked for.

Perhaps further evidence in this direction comes from two new
observations I have made: there is no delay when visiting a PDF file via
bookmark-jump or when opening a PDF attachment in Gnus.  I tried
stepping through the respective functions called in these cases
(pdf-view-bookmark-jump-handler and mm-display-external) but didn't see
why the behavior differs, which again suggests it's in redisplay.

Steve Berman